
//	base code for simple applications
//  Copyright (c) 2002 Takeo Igarashi 

import java.awt.event.*;
import java.awt.*;
import java.util.*;


class MainPanel extends Panel implements ButtonsInterface
{

	//
	// initialize
	//
	MainPanel(){
		MouseDispatcher mouseDispatcher = new MouseDispatcher();
		addMouseListener(mouseDispatcher);
		addMouseMotionListener(mouseDispatcher);
		
	}
	
	//
	// set buttons
	//
	public void initializeButtons(Buttons buttons){
		buttons.addButton("quit");
		buttons.addButton("init");
	}
	public void buttonPressed(String label){
		if (label.equals("quit"))
			System.exit(0);
		else if (label.equals("init"))
			init();
	}
	
	public void init(){
		stroke = new Vector();
		repaint();
	}
	
	
	
	

	

	
	//
	// paint screen
	//
	Image buffered_image = null;
	public void update(Graphics g) {
		paint(g);
	}
	public void paint(Graphics g) {

		//double buffering
		if (buffered_image == null)
			buffered_image = createImage(getSize().width, getSize().height);
		Graphics bg = buffered_image.getGraphics();

		// clear
		bg.setColor(Color.white);
		bg.fillRect(0,0, getSize().width, getSize().height);

		// paint code!
		bg.setColor(Color.black);
		paint_stroke(bg, stroke);

		//double buffering
		bg.dispose();
      
		g.drawImage(buffered_image,0,0,this);

	}
	
	public void paint_stroke(Graphics g, Vector stroke){
		for(int i=0; i<stroke.size()-1; i++){
			Point p = (Point) stroke.elementAt(i);
			Point q = (Point) stroke.elementAt(i+1);
			g.drawLine(p.x, p.y, q.x, q.y);
		}
	}
	
	
	
	
	
	
	
	
	
	
	//
	// event handling
	//
	long time;
	Vector stroke = new Vector();
	public void start_stroke(Point p){
		time = System.currentTimeMillis();
		
		stroke = new Vector();
		extend_stroke(p);
	}
	public void extend_stroke(Point p){
		stroke.addElement(p);
		repaint();
	}
	public void finish_stroke(Point p){
		System.out.println("drawing time = "+(System.currentTimeMillis()-time));
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
   
	//   
	// central event dispatcher
	//
	public class MouseDispatcher 
		extends MouseAdapter implements MouseMotionListener{

  		public void mouseMoved(MouseEvent e) {
  		}
  		public void mouseDragged(MouseEvent e) {
			extend_stroke(e.getPoint());
   		}
  		public void mousePressed(MouseEvent e) {
			start_stroke(e.getPoint());
		}
		public void mouseReleased(MouseEvent e) {
			finish_stroke(e.getPoint());
		}
    }
}







